<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '../common/meta';
import { smallBusinessDataHelper } from '../services/small-business.service';
import { IsMobileMixin } from '../mixins';
import { SmbValueProp } from '../components/small-business/index.vue';
import {
  CardBasicStyle,
  DemoModal,
  IntegratedApplications,
  NextStepAlt,
  PricingTiers,
  QuoteCarousel,
  SideNavigationVariant,
} from '../components/common/index.vue';
import { SolutionsHero } from '../components/solutions/index.vue';
import { CONTENT_TYPES } from '../common/content-types';
import { getClient } from '../plugins/contentful';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { LivePreviewMixin } from '~/mixins';
import { convertToCaseSensitiveLocale } from '~/common/util';

export default Vue.extend({
  components: {
    SideNavigationVariant,
    SolutionsHero,
    SmbValueProp,
    QuoteCarousel,
    NextStepAlt,
    CardBasicStyle,
    PricingTiers,
    DemoModal,
    IntegratedApplications,
  },
  mixins: [LivePreviewMixin, IsMobileMixin],
  async asyncData({ i18n }: any) {
    const { items } = await getClient().getEntries({
      content_type: CONTENT_TYPES.PAGE,
      'sys.id': '1TFUqzzJNPOtRgKU9RfDRL',
      include: 10,
      locale: convertToCaseSensitiveLocale(i18n.locale),
    });

    const doc = smallBusinessDataHelper(items);

    return { doc, items };
  },
  data() {
    return {
      modal: {
        open: false,
      },
    };
  },
  head(): MetaInfo {
    return getPageMetadata(
      this.doc,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) => {
          this.doc = smallBusinessDataHelper(updatedData);
        },
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
  methods: {
    openModal() {
      this.modal.open = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
    closeModal() {
      this.modal.open = false;
    },
  },
});
</script>

<template>
  <div class="overflow-clip small-business">
    <SolutionsHero :data="doc.solutions_hero" />
    <SideNavigationVariant :links="doc['side_navigation_links']">
      <SmbValueProp id="capabilities" :data="doc.by_solution_value_prop" />
      <CardBasicStyle id="demo" no-hover>
        <div class="video-text">
          <SlpTypography class="slp-mb-24" tag="h3" variant="heading4-bold">
            {{ doc.demo?.demo.title }}
          </SlpTypography>
          <SlpTypography class="slp-mb-24" tag="div" variant="body1">
            {{ doc.demo?.demo.description }}
          </SlpTypography>
        </div>
        <div class="video">
          <div
            class="image__container"
            :data-ga-location="doc.demo.launchButton.data_ga_location"
            :data-ga-name="doc.demo.launchButton.data_ga_name"
            @click="openModal"
          >
            <img
              class="demo-thumbnail"
              :src="doc.demo.demo.video.thumbnail"
              :alt="doc.demo.demo.video.altText"
            />
            <SlpButton variant="secondary" class="slp-mt-32 demo-button">
              <SlpIcon
                :name="doc.demo.launchButton.icon_name"
                :variant="doc.demo.launchButton.icon_variant"
                alt="laptop-play-video"
              />{{ doc.demo.launchButton.text }}</SlpButton
            >
          </div>
        </div>

        <DemoModal
          v-show="modal.open"
          :data="doc.demo.demo"
          :visible="modal.open"
          @close="closeModal"
        >
        </DemoModal>
      </CardBasicStyle>
      <IntegratedApplications
        v-if="doc.integrated_applications"
        id="integrations"
        :data="doc.integrated_applications"
      />
      <QuoteCarousel
        id="case-studies"
        v-bind="doc.by_industry_case_studies"
        :dark-mode="true"
      />
      <PricingTiers id="pricing" :data="doc.pricing_tier"></PricingTiers>
      <section class="small-business__card">
        <CardBasicStyle>
          <template #header>
            {{ doc.card_content?.title }}
          </template>
          <SlpTypography class="slp-mb-24" tag="div" variant="body1">
            {{ doc.card_content?.description }}
          </SlpTypography>
          <SlpButton
            variant="primary"
            class="slp-mt-32"
            :data-ga-name="doc.card_content?.button.data_ga_name"
            :data-ga-location="doc.card_content?.button.data_ga_location"
            :href="doc.card_content?.button.href"
          >
            {{ doc.card_content?.button.text }}
          </SlpButton>
        </CardBasicStyle>
      </section>
    </SideNavigationVariant>
    <NextStepAlt />
  </div>
</template>

<style scoped lang="scss">
.small-business {
  &__card {
    min-height: 252px;
    margin: $spacing-48 0 $spacing-160;
    max-width: 100%;
  }
}
#demo {
  padding: 48px;
  margin-bottom: 96px;
  display: flex;
  flex-direction: row;
  align-items: center;
  .video-text {
    display: flex;
    flex-direction: column;
    justify-content: center;
    flex: 2 1 0;
    padding-left: $spacing-8;
  }
  .video {
    max-width: 460px;
    height: fit-content;
    display: flex;
    flex: 2 1 0;
    .image__container {
      display: flex;
      position: relative;
      border-radius: 4px;
      border: 0.5px solid black;
      overflow: hidden;
      &::before {
        content: '';
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        background: linear-gradient(
          to bottom,
          rgba(110, 73, 203, 0.3) rgba(255, 212, 216, 0.45)
        );
        opacity: 0;
        transition: opacity 0.3s ease-in-out;
      }
      &:hover::before {
        opacity: 1;
      }
    }
    .demo-thumbnail {
      max-width: 100%;
      display: block;
      height: auto;
      filter: blur(1px);
      z-index: 1;
      transition: filter 0.3s ease-in-out;
      &:hover {
        z-index: 0;
        cursor: pointer;
        background: linear-gradient(
          to bottom,
          rgba(110, 73, 203, 0.3) rgba(255, 212, 216, 0.45)
        );
      }
    }
  }
  .demo-button {
    position: absolute;
    top: 37%;
    left: 50%;
    transform: translate(-50%, -50%);
    z-index: 2;
    border-radius: 30px;
    &:hover {
      box-shadow: 0 2px 50px rgba($color-surface-700, 0.25);
    }
    .slp-icon {
      margin-right: 5px;
      width: 24px;
      height: 24px;
    }
  }
  @media (max-width: $breakpoint-sm) {
    display: flex;
    flex-direction: column;
    padding: $spacing-32;

    .image__container {
      max-width: 100%;
    }
    .video-text {
      padding: 0 0 $spacing-8 0;
    }

    .video {
      width: fit-content;
      display: flex;
      flex-wrap: wrap;
      align-items: center;
    }

    .demo-button {
      position: absolute;
      top: 35%;
      left: 50%;
      font-size: 16px;
      width: 170px;
      transform: translate(-50%, -50%);
    }
  }
}
</style>
